<template>
  <div id="jobinfo">
    <jobinfo-detail :info="site" :menuList="menu" :backColor="backColor" :Color="Color" :jobinfoInfo="jobInfo" :jobslist="jobList"></jobinfo-detail>
  </div>
</template>

<script>
import jobinfoDetail from '@/components/jobinfo.vue';
import { mapActions, mapState } from 'vuex';
import _ from 'lodash';
export default {
  metaInfo() {
    return {
      title: this.siteTitle ? this.siteTitle : '就业信息网',
    };
  },
  name: 'jobinfo',
  props: {},
  components: {
    jobinfoDetail,
  },
  data: () => ({
    backColor: '#0457c7',
    Color: '#0457c7',
    jobInfo: {},
    jobList: [],
    menu: [],
    site: {},
    siteTitle: '',
  }),
  async created() {
    await this.toGetSite(); //获取主站信息
    await this.loadMenu(); //获取菜单信息
    this.search();
  },
  computed: {},
  methods: {
    ...mapActions(['getSite', 'getMenu', 'getColumn', 'getPosts', 'getJobInfo']),
    async search() {
      //1直接拿着参数发送请求
      let result = await this.getJobInfo({ type: 'search', data: { id: this.$route.query.id } });
      if (`${result.errcode}` === '0') {
        //给this=>vue的实例下在中的list属性，赋予result.data的值
        this.$set(this, `jobInfo`, result.data);
        this.searchJobs();
      } else {
        this.$message.error(result.errmsg ? result.errmsg : 'error');
      }
    },
    async searchJobs() {
      let result;
      let jobIds = this.jobInfo.jobs.length > 0 ? this.jobInfo.jobs : [];
      let jobList = [];
      for (const item of jobIds) {
        result = await this.getPosts({ type: 'fetch', data: { id: item } });
        if (`${result.errcode}` === '0') {
          jobList.push(result.data);
        }
      }
      this.$set(this, `jobList`, jobList);
    },
    //站点信息
    async toGetSite() {
      let site = sessionStorage.getItem('site');
      if (site) {
        this.$set(this, `site`, JSON.parse(site));
        this.$set(this, `siteTitle`, this.site.name);
      } else {
        let result = await this.getSite({ type: 'search' });
        if (result.errcode === 0) {
          sessionStorage.setItem('site', JSON.stringify(result.data));
          if (_.get(result.data, `custom`)) {
            let item = result.custom;
          }
          this.$set(this, `site`, result.data);
          this.$set(this, `siteTitle`, this.site.name);
        }
      }
    },
    //菜单
    async loadMenu() {
      let menu = sessionStorage.getItem('menu');
      if (menu) {
        this.$set(this, `menu`, JSON.parse(menu));
        await this.finishedMenu();
      } else this.toGetMenu();
    },
    async toGetMenu() {
      let result = await this.getMenu({ type: `list` });
      if (result.errcode === 0) {
        sessionStorage.setItem('menu', JSON.stringify(result.data));
        this.$set(this, `menu`, result.data);
        this.finishedMenu();
      }
    },
    async finishedMenu() {
      let menus = JSON.parse(JSON.stringify(this.menu));
      for (const item of menus) {
        if (item.type === 'content') {
          item.path = `/detail/${item.content_id}`;
        } else if (item.type !== 'url') {
          let res = await this.completeMenu(item);
          item.children = res;
        }
      }
      this.$set(this, `menu`, menus);
    },
    async completeMenu(item) {
      let result = await this.getColumn({
        type: `list`,
        data: { parent_id: item.id },
      });
      if (result.errcode === 0) {
        let columns = result.data;
        for (const col of columns) {
          if (col.type === 'content') {
            col.path = `/detail/${col.content_id}`;
          } else if (col.type !== 'url') {
            col.path = `/newsList/menu/${col.id}?title=${col.title}`;
            if (col.parent.includes('党员')) {
              col.path = `/memberList/menu/${col.id}?title=${col.title}`;
            }
          }
        }
        return columns;
      }
    },
  },
};
</script>

<style lang="less" scoped></style>
